%% ANOVA test on features 
dataSet = {'St_Vincents','ECG_DB'};
ObAll = [];
labelAll = [];
selectFeats = {'Power_Wavdb1D_2'};
% selectFeats = {'Power_Wavdb1D_2','Wav_db1_L3Num','Wav_db1_L2Num'};    
for dataInd = 1:2
    if strcmp(dataSet{dataInd},'St_Vincents')
        respLv = 3; % problems equal and worse will be considered: 1--possible, 3--hyp, 4--apnea
        fileDir = fullfile('../Features4HealthySleep/Wavelet/AllFeatPro_ovlp_20/',dataSet{dataInd});
    elseif strcmp(dataSet{dataInd},'ECG_DB')
        respLv = 1;
        fileDir = fullfile('../Features4HealthySleep/Wavelet/AllFeatPro_ovlp_20_ds/',dataSet{dataInd});
    end
    % trainPropt = 0.7;

    featAll = [];
    gtAll = [];
    files = dir(fileDir);
    for fileInd = 1:length(files)
        if files(fileInd).isdir
            continue;
        end
        fileName = files(fileInd).name;
        load(fullfile(fileDir,fileName),'featStruct');
        featAll = cat(1,featAll,featStruct.feat);
        gtAll = cat(1,gtAll,featStruct.segGt);
    end

    featNum = length(featStruct.featNames);

    % perfStruct = struct('feats',cell(2,1),'accuracy', [], ...
    %                                     'sensitivity', [], 'specificity', []);

    allFeats = featStruct.featNames;    
    selectInd = arrayfun(@(j)find(arrayfun(@(i)strcmp(selectFeats{j}, allFeats{i}),...
        1:length(allFeats))),1:length(selectFeats));
    prbFeat = featAll(bsxfun(@and,gtAll>=respLv, ~isnan(featAll(:,2))),selectInd); % attention for NaN check
    normalFeat = featAll(bsxfun(@and,gtAll==0, ~isnan(featAll(:,2))),selectInd);
    prbNum = size(prbFeat,1);
    normalNum = size(normalFeat,1);
    gtLabel = cat(1,true(prbNum,1),false(normalNum,1));
    ObAll = cat(1,ObAll,prbFeat, normalFeat);
    labelAll = cat(1,labelAll, gtLabel);
end

[p,tbl,stats] = anova1(ObAll,labelAll);
disp('End');