% The codes perform resampled KS test on the k-fold results 
% **********************************************************************
dataSet = 'ECG_DB';
fileDir = fullfile('../Features4HealthySleep/Wavelet/AllFeatPro_ovlp_20_ds/',dataSet);
if strcmp(dataSet,'St_Vincents')
    respLv = 3; % problems equal and worse will be considered: 1--possible, 3--hyp, 4--apnea
elseif strcmp(dataSet,'ECG_DB')
    respLv = 1;
end
% trainPropt = 0.7;

featAll = [];
gtAll = [];
files = dir(fileDir);
for fileInd = 1:length(files)
    if files(fileInd).isdir
        continue;
    end
    fileName = files(fileInd).name;
    load(fullfile(fileDir,fileName),'featStruct');
    featAll = cat(1,featAll,featStruct.feat);
    gtAll = cat(1,gtAll,featStruct.segGt);
end

featNum = length(featStruct.featNames);

% perfStruct = struct('feats',cell(2,1),'accuracy', [], ...
%                                     'sensitivity', [], 'specificity', []);

allFeats = featStruct.featNames;
selectFeats = {'t_M2','MinV','Power_Wavdb1D_2','Wav_db1_L3Num','Wav_db1_L2Num','Rg'};
% selectFeats = {'Power_Wavdb1D_2','Wav_db1_L3Num','Wav_db1_L2Num'};    
selectInd = arrayfun(@(j)find(arrayfun(@(i)strcmp(selectFeats{j}, allFeats{i}),...
    1:length(allFeats))),1:length(selectFeats));
prbFeat = featAll(bsxfun(@and,gtAll>=respLv, ~isnan(featAll(:,2))),selectInd); % attention for NaN check
normalFeat = featAll(bsxfun(@and,gtAll==0, ~isnan(featAll(:,2))),selectInd);
prbNum = size(prbFeat,1);
normalNum = size(normalFeat,1);
gtLabel = cat(1,true(prbNum,1),false(normalNum,1));

testNum = 100;
% subsetNum = 1;
% prbSubsetSz = floor(prbNum/subsetNum);
% normSubsetSz = floor(normalNum/subsetNum);
% prbRndInd = randperm(prbNum);
% normRndInd = randperm(normalNum);

dpAcc = zeros(testNum,1);
svmAcc = zeros(testNum, 1);
ldaAcc = zeros(testNum, 1);
for cvInd = 1:testNum
    % cross validation with k-folds
%     seed = 100; s = rng(seed,'twister'); % make sure each feat are trained and the tested on the same partitions
    cp = cvpartition(gtLabel,'k',10); % Stratified cross-validation
    order = unique(gtLabel);
    % 
    fDP = @(xTrain, yTrain, xTest,yTest)confusionmat(yTest,...
        DP_Classify(xTrain, yTrain, xTest, 'multiVari'),'order',order);
    % SVM for comparison
    fSVM = @(xTrain, yTrain, xTest,yTest)confusionmat(yTest,...
        SVM_Classify(xTrain, yTrain, xTest),'order',order);
    % Discriminant Analysis
    fLDA = @(xtr,ytr,xte,yte)confusionmat(yte,...
    classify(xte,xtr,ytr),'order',order);


    cfMat_DP = crossval(fDP,cat(1,prbFeat,normalFeat),gtLabel,'partition',cp);
    cfMat_DP = reshape(sum(cfMat_DP),2,2);
    dpAcc(cvInd) = trace(cfMat_DP)/sum(cfMat_DP,'All');
    
    cfMat_SVM = crossval(fSVM,cat(1,prbFeat,normalFeat),gtLabel,'partition',cp);
    cfMat_SVM = reshape(sum(cfMat_SVM),2,2);
    svmAcc(cvInd) = trace(cfMat_SVM)/sum(cfMat_SVM,'All');
    
    cfMat_LDA = crossval(fLDA,cat(1,prbFeat,normalFeat),gtLabel,'partition',cp);
    cfMat_LDA = reshape(sum(cfMat_LDA),2,2);
    ldaAcc(cvInd) = trace(cfMat_LDA)/sum(cfMat_LDA,'All');
    
    % confusionchart(cfMat,order)
%     sens = cfMat_DP(order==true,order==true)/sum(cfMat_DP(order==true,:));
%     spec = cfMat_DP(order==false,order==false)/sum(cfMat_DP(order==false,:));
%     acc = trace(cfMat_DP)/sum(cfMat_DP,'All');
%     fprintf('10-folds Accuracy:%f, Sensitivity:%f, Specificity:%f\n',acc, sens, spec);
%     perfStruct.feats = selectFeats;
%     perfStruct.accuracy = acc;
%     perfStruct.sensitivity = sens;
%     perfStruct.specificity = spec;
end 
save('ECG_resampled_CV.mat','dpAcc','svmAcc','ldaAcc');

% resampled KS test
[h,p,kstats] = kstest2(dpAcc,ldaAcc,'Alpha',0.01)

[h,p,kstats] = kstest2(dpAcc,svmAcc,'Alpha',0.01)

