% The codes conduct corrected resampled t-test on the results of k-folds validation with 
% the DPGMM models
% **********************************************************************
dataSet = 'St_Vincents';
fileDir = fullfile('../Features4HealthySleep/Wavelet/AllFeatPro_ovlp_20/',dataSet);
if strcmp(dataSet,'St_Vincents')
    respLv = 3; % problems equal and worse will be considered: 1--possible, 3--hyp, 4--apnea
elseif strcmp(dataSet,'ECG_DB')
    respLv = 1;
end
% trainPropt = 0.7;

featAll = [];
gtAll = [];
files = dir(fileDir);
for fileInd = 1:length(files)
    if files(fileInd).isdir
        continue;
    end
    fileName = files(fileInd).name;
    load(fullfile(fileDir,fileName),'featStruct');
    featAll = cat(1,featAll,featStruct.feat);
    gtAll = cat(1,gtAll,featStruct.segGt);
end

% ind = ff2n(length(featStruct.featNames));
% % ind = ff2n(7);
% ind = ind(2:end,:);
% tmp = 1:length(featStruct.featNames);
% % tmp = 1:7;
% featSubset = arrayfun(@(i)tmp(logical(ind(i,:))),1:size(ind,1),'un',0)';
% clear tmp;clear ind;
featNum = length(featStruct.featNames);

% perfStruct = struct('feats',cell(2,1),'accuracy', [], ...
%                                     'sensitivity', [], 'specificity', []);

allFeats = featStruct.featNames;
selectFeats = {'t_M2','MinV','Power_Wavdb1D_2','Wav_db1_L3Num','Wav_db1_L2Num','Rg'};
% selectFeats = {'Power_Wavdb1D_2','Wav_db1_L3Num','Wav_db1_L2Num'};    
selectInd = arrayfun(@(j)find(arrayfun(@(i)strcmp(selectFeats{j}, allFeats{i}),...
    1:length(allFeats))),1:length(selectFeats));
prbFeat = featAll(bsxfun(@and,gtAll>=respLv, ~isnan(featAll(:,2))),selectInd); % attention for NaN check
normalFeat = featAll(bsxfun(@and,gtAll==0, ~isnan(featAll(:,2))),selectInd);
prbNum = size(prbFeat,1);
normalNum = size(normalFeat,1);
gtLabel = cat(1,true(prbNum,1),false(normalNum,1));

subsetNum = 1;
prbSubsetSz = floor(prbNum/subsetNum);
normSubsetSz = floor(normalNum/subsetNum);
prbRndInd = randperm(prbNum);
normRndInd = randperm(normalNum);

dpAcc = zeros(subsetNum,1);
svmAcc = zeros(subsetNum, 1);
ldaAcc = zeros(subsetNum, 1);
for cvInd = 1:subsetNum
    prbFeatSub = prbFeat(prbRndInd((cvInd-1)*prbSubsetSz+1:cvInd*prbSubsetSz),:);
    normFeatSub = normalFeat(normRndInd((cvInd-1)*normSubsetSz+1:cvInd*normSubsetSz),:);
    % cross validation with k-folds
%     seed = 100; s = rng(seed,'twister'); % make sure each feat are trained and the tested on the same partitions
    subGt = cat(1,true(prbSubsetSz,1),false(normSubsetSz,1));
    cp = cvpartition(subGt,'k',10); % Stratified cross-validation
    order = unique(subGt);
    % 
    fDP = @(xTrain, yTrain, xTest,yTest)confusionmat(yTest,...
        DP_Classify(xTrain, yTrain, xTest, 'multiVari'),'order',order);
    % SVM for comparison
    fSVM = @(xTrain, yTrain, xTest,yTest)confusionmat(yTest,...
        SVM_Classify(xTrain, yTrain, xTest),'order',order);
    % Discriminant Analysis
    fLDA = @(xtr,ytr,xte,yte)confusionmat(yte,...
    classify(xte,xtr,ytr),'order',order);


    cfMat_DP = crossval(fDP,cat(1,prbFeatSub,normFeatSub),subGt,'partition',cp);
    cfMat_DP = reshape(sum(cfMat_DP),2,2);
    dpAcc(cvInd) = trace(cfMat_DP)/sum(cfMat_DP,'All');
    
    cfMat_SVM = crossval(fSVM,cat(1,prbFeatSub,normFeatSub),subGt,'partition',cp);
    cfMat_SVM = reshape(sum(cfMat_SVM),2,2);
    svmAcc(cvInd) = trace(cfMat_SVM)/sum(cfMat_SVM,'All');
    
    cfMat_LDA = crossval(fLDA,cat(1,prbFeatSub,normFeatSub),subGt,'partition',cp);
    cfMat_LDA = reshape(sum(cfMat_LDA),2,2);
    ldaAcc(cvInd) = trace(cfMat_LDA)/sum(cfMat_LDA,'All');
    
    % confusionchart(cfMat,order)
%     sens = cfMat_DP(order==true,order==true)/sum(cfMat_DP(order==true,:));
%     spec = cfMat_DP(order==false,order==false)/sum(cfMat_DP(order==false,:));
%     acc = trace(cfMat_DP)/sum(cfMat_DP,'All');
%     fprintf('10-folds Accuracy:%f, Sensitivity:%f, Specificity:%f\n',acc, sens, spec);
%     perfStruct.feats = selectFeats;
%     perfStruct.accuracy = acc;
%     perfStruct.sensitivity = sens;
%     perfStruct.specificity = spec;
end 
save('Indp_Test_Result_5sub.mat','dpAcc','svmAcc','ldaAcc');
% corrected resampled t-test
d = dpAcc - svmAcc;
t = mean(d)/(sqrt(1/(subsetNum*10)+1/9)*std(d)); % DPMM & SVM
p = tcdf(t,subsetNum-1,'upper')

d = dpAcc - ldaAcc;
t = mean(d)/(sqrt(1/(subsetNum*10)+1/9)*std(d)); % DPMM & SVM
p = tcdf(t,subsetNum-1,'upper')
